package pl.edu.pjwstk.nbd.cw6

object Main {
  def main(args: Array[String]): Unit = {
    def daysOfWeek = List("MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY", "SUNDAY")
    println("===== ZADANIE 1.1 ======")
    Zad1.printFor(daysOfWeek)
    println("===== ZADANIE 1.2 ======")
    Zad1.printStartingWithP(daysOfWeek)
    println("===== ZADANIE 1.3 ======")
    Zad1.printForEach(daysOfWeek)
    println("===== ZADANIE 1.4 ======")
    Zad1.printWhile(daysOfWeek)
    println("===== ZADANIE 1.5 ======")
    Zad1.printRecursive(daysOfWeek)
    println("===== ZADANIE 1.6 ======")
    Zad1.printRecursiveReversed(daysOfWeek)
    println("===== ZADANIE 1.7 ======")
    Zad1.printFold(daysOfWeek)
    println("===== ZADANIE 1.8 ======")
    Zad1.printFoldStartingWithP(daysOfWeek)
    println("===== ZADANIE 2 ======")
    println("BEFORE DISCOUNT")
    println(Zad2.products)
    println("AFTER DISCOUNT")
    println(Zad2.productsAfterDiscount)
    println("===== ZADANIE 3 ======")
    Zad3.printTriple(("some string", 1, 1.0))
    println("===== ZADANIE 4 ======")
    println("Should return [20.0]:")
    println(Zad4.demonstrateOption(Zad4.products, "T-SHIRT", 1000.0))
    println("Should return [1000.0]:")
    println(Zad4.demonstrateOption(Zad4.products, "BlaBla", 1000.0))
    println("===== ZADANIE 5 ======")
    println("Should return [Praca]:")
    println(Zad5.patternMatching("MONDAY"))
    println("Should return [Weekend]:")
    println(Zad5.patternMatching("SATURDAY"))
    println("Should return [Nie ma takiego dnia]:")
    println(Zad5.patternMatching("Blabla"))
    println("===== ZADANIE 6 ======")
    // Bank account
    println("===== ZADANIE 7 ======")
    println("Should return [Hi]:")
    println(Zad7.sayHi(Zad7.firstPerson))
    println("Should return [Hi Hi]:")
    println(Zad7.sayHi(Zad7.secondPerson))
    println("Should return [Hi Hi Hi]:")
    println(Zad7.sayHi(Zad7.thirdPerson))
    println("===== ZADANIE 8 ======")
    println("Should return [1,2,3,4,5]:")
    println(Zad8.removeZeros(List(0,1,0,2,3,4,0,5)))
    println("===== ZADANIE 9 ======")
    println("Should return [1,2,3,4,5]:")
    println(Zad9.addOne(List(0,1,2,3,4)))
    println("===== ZADANIE 10 ======")
    println("Should return [4.2, 1, 0, 10, 12]:")
    println(Zad10.toAbsWhenInRange(List(-6, -4.2, -1, 0, 10, 12, 100)))

  }
}